/* -*- tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
import lejos.nxt.*;
import java.util.ArrayList;

/**
 * A behavior that uses an ultrasonic sensor on port S2
 * to make Marvin avoid objects in front of it, by driving back and then 
 * turn right.
 *  
 * @author Bent Bisballe Nyeng, Kasper Sohn and Johnny Rieper
 * @version January 2009
 */
public class AvoidFront extends Behavior 
{
  /**
   * AvoidFront constructor.
   * @param behaviors List of lower priority behaviours.
   * @param ctrl The motor control parameters.
   */
  public AvoidFront(ArrayList behaviors, Ctrl ctrl)
  {
    super(behaviors, ctrl);
  }
   
  public void run() 
  {
    UltrasonicSensor us = new UltrasonicSensor(SensorPort.S2);
    int tooCloseThreshold = 20; // cm

    while (true) {
      int distance = us.getDistance();
      while(distance > tooCloseThreshold) {
        distance = us.getDistance();
        delay(100);
      }

      suppressLower();
		    
      backward(5000);
      right(1200);
      stop(2000);

      unsuppressLower();
    }
  }
}
