/* -*- tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
import lejos.nxt.*;
import java.lang.*;
import java.util.ArrayList;

/**
 * Marvin main program.
 * It sets up the balance controller, and three behaviors.
 * It runs until the escape button is pressed.
 *
 * @author Bent Bisballe Nyeng, Kasper Sohn and Johnny Rieper
 * @version January 2009
 */
class Marvin {
  static Ctrl ctrl;

  public static void main(String [] args)
  {
    // Hold still in balancing position.
    try { Thread.sleep(1000); } catch(InterruptedException e) { }

    ctrl = new Ctrl();

    BalanceControl bc = new BalanceControl(ctrl);
    bc.start();

    ArrayList behaviors = new ArrayList();

    RandomDrive rd;
    AvoidFront af;
    BTController bt;

    rd = new RandomDrive(behaviors, ctrl); behaviors.add(rd);
    af = new AvoidFront(behaviors, ctrl); behaviors.add(af);
    bt = new BTController(behaviors, ctrl); behaviors.add(bc);
	
    rd.start();
    af.start();
    bt.start();

    while (! Button.ESCAPE.isPressed()) {
      try { Thread.sleep(500); } catch(InterruptedException e) { }
    }
  }
}