/* -*- tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
import lejos.nxt.*;
import java.lang.*;

/**
 * A LCD output wrapper class, that can output floating decimal numbers,
 * integers, and strings with labels.
 *
 * @author Bent Bisballe Nyeng, Kasper Sohn and Johnny Rieper
 * @version January 2009
 */
public class Print
{
  // Change this to enable/disable LCD output.
  public final boolean debug = false;

  /**
   * Print a double with a label.
   * @param label The label to print to the left of the number.
   * @param val The double value to print.
   * @param x The x-coordinate in which to print the number.
   * @param y The y-coordinate in which to print the number.
   */
  public static void number(String label, double val, int x, int y)
  {
    if(debug == false) return;

    LCD.drawString(label, x, y);
    x += label.length();

    Integer i = new Integer((int)Math.floor(val));
    String istr = i.toString();

    // HACK: Print floor(number) * 10000 and replace first integer with a .
    Integer d = new Integer((int)((val - Math.floor(val)) *10000) + 10000);
    String dstr = d.toString();
    LCD.drawString(istr + dstr + "      ", x, y);
    LCD.drawString(istr + ".", x, y);
  }

  /**
   * Print a ineter with a label.
   * @param label The label to print to the left of the number.
   * @param val The integer value to print.
   * @param x The x-coordinate in which to print the number.
   * @param y The y-coordinate in which to print the number.
   */
  public static void number(String label, int val, int x, int y)
  {
    if(debug == false) return;

    LCD.drawString(label, x, y);
    x += label.length();
    Integer i = new Integer(val);
    LCD.drawString(i.toString() + "    ", x, y);
  }

  /**
   * Print a string.
   * @param val The string value to print.
   * @param x The x-coordinate in which to print the number.
   * @param y The y-coordinate in which to print the number.
   */
  public static void string(String label, String val, int x, int y)
  {
    if(debug == false) return;

    LCD.drawString(label + val, x, y);
  }
}
