/* -*- tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
import java.util.ArrayList;
import java.lang.*;

/**
 * A behavior that makes Marvin drive around randomly, by selecting 
 * one of four directions (back, forth, left and right) and driving
 * in that direction for 2000ms to 6000ms.
 *
 * @author Bent Bisballe Nyeng, Kasper Sohn and Johnny Rieper
 * @version January 2009
 */
public class RandomDrive extends Behavior 
{
  /**
   * RandomDrive constructor.
   * @param behaviors List of lower priority behaviours.
   * @param ctrl The motor control parameters.
   */
  public RandomDrive(ArrayList behaviors, Ctrl ctrl)
  {
    super(behaviors, ctrl);
  }
  
  public void run()
  {
    stop(1000);
    
    while(true) {  
	    suppressLower();
	    
	    int dir = (int)(Math.random() * 4);
	    int time = (int)(Math.random() * 4000) + 2000;
	    switch(dir) {
	    case 0:
        forward(time);
        break;
	    case 1:
        backward(time);
        break;
	    case 2:
        left(time / 4);
        break;
	    case 3:
        right(time / 4);
        break;
	    }
      
	    stop(2000);
      
	    unsuppressLower();
    }
  }
}
